var action = "save";
var plqr_id = "";
var tableData = undefined;
var checkedBy = getCheckedBy();
$(document).ready(function () {
    tableData = $("#tblData").transactionTable({
        thead: [
            "Hour",
            "S1",
            "S2",
            "S3",
            "S4",
            "S5",
            "SED",
            "SLD",
            "PRD",
            "PAD",
            "TOTAL",
            "S Length",
            "Checked By",
        ],
        column_def: { 0: 100 },
        auto_focus: 0,
        row_type: [
            { type: "select", value: "", align: "left", width: "60px" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left", disabled: "disabled" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left", disabled: "disabled" },
            { type: "text", value: "", align: "left" },
            { type: "select", value: [], align: "left", width: "150px" },
            { type: "remove", value: "X", align: "center" },
        ],
    });

    getOrderNo();
    getProductPrimaryId();

    $("#tblData").on("click", "td", function () {
        var selected_row = tableData.getSelectedRow();
    });

    if (window.location.search.length > 0) {
        var sPageURL = window.location.search.substring(1);
        var param = sPageURL.split("?");
        plqr_id = param[0].split("=")[1].split("&")[0];
        action = param[0].split("=")[2].split("&")[0];
        getPlqData(plqr_id);
        if (action == "edit") {
            $("#btnSave").text("Update");
        } else if (action == "view") {
            $("#btnSave").hide();
            $("#addRowBtn").hide();
            $("#product_primary_id").prop("disabled", true);
            $("#customer_order_plan_data_id").prop("disabled", true);
            $("#trans_date").prop("disabled", true);
        }
    } else {
        tableData.add_empty_row();
    }

    $("#btnSave").on("click", function () {
        if ($(this).text() == "Save") {
            savePlqRecord();
        } else {
            updatePlqRecords(plqr_id);
        }
    });

    addRowData();
});

function addEmptyRow() {
    tableData.add_empty_row();
    addRowData();
}

function addRowData(checked, hour) {

    var selected_row = tableData.getSelectedRow();
    var cells = selected_row.getElementsByTagName("td");

    $("#" + cells[0].childNodes[0].id).append(
        '<option value="">--</option>'
    );

    $("#" + cells[12].childNodes[0].id).append(
        '<option value="">--Select--</option>'
    );

    for (var i = 0; i < checkedBy.length; i++) {
        if (checked == checkedBy[i].employee_id) {
            $("#" + cells[12].childNodes[0].id).append(
                '<option value="' +
                checkedBy[i].employee_id +
                    '" selected>' +
                    checkedBy[i].name_withinitial +
                    "</option>"
            );
        } else {
            $("#" + cells[12].childNodes[0].id).append(
                '<option value="' +
                checkedBy[i].employee_id +
                    '">' +
                    checkedBy[i].name_withinitial +
                    "</option>"
            );
        }
    }
    for (var i = 1; i < 25; i++) {
        if (hour == i) {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' + i + '" selected>' + i + "</option>"
            );
        } else {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' + i + '">' + i + "</option>"
            );
        }
    }
}

function getCheckedBy() {
    var data = [];
    $.ajax({
        type: "GET",
        url: "/qc/PackingLineQualityRecordDataController/getCheckedBy",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            for (var i = 0; i < response.data.result.length; i++) {
                data.push({
                    employee_id: response.data.result[i].employee_id,
                    name_withinitial: response.data.result[i].name_withinitial,
                });
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });

    return data;
}

function getOrderNo() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getOrderNo",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#customer_order_plan_data_id").append(
                    '<option value="' +
                        res[i].customer_order_plan_data_id +
                        '">' +
                        res[i].order_id +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getProductPrimaryId() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getProductPrimaryId",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            for (var i = 0; i < res.length; i++) {
                $("#product_primary_id").append(
                    '<option value="' +
                        res[i].product_primary_id +
                        '">' +
                        res[i].product_name +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function savePlqRecord() {
    var plq_data = {};
    var plq_data_arr = tableData.dataSource();
    if (plq_data_arr.length == 0) {
        showWarningMessage("Invalid data!");
        return;
    }
    for (var i = 0; i < plq_data_arr.length; i++) {
        if (!plq_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        plq_data[i] = JSON.stringify({
            hour: plq_data_arr[i][0],
            seal_damage1: plq_data_arr[i][1],
            seal_damage2: plq_data_arr[i][2],
            seal_damage3: plq_data_arr[i][3],
            seal_damage4: plq_data_arr[i][4],
            seal_damage5: plq_data_arr[i][5],
            slab_damage: plq_data_arr[i][6],
            print_damage: plq_data_arr[i][7],
            packing_damage: plq_data_arr[i][8],
            sealing_length: plq_data_arr[i][11],
            checked_by: plq_data_arr[i][12],
        });
    }

    $.ajax({
        type: "POST",
        url: "/qc/PackingLineQualityRecordDataController/save",
        data: {
            'trans_date': $("#trans_date").val(),
            'customer_order_plan_data_id': $(
                "#customer_order_plan_data_id"
            ).val(),
            'product_primary_id': $("#product_primary_id").val(),
            'plq_data': plq_data,
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data saved");
                $("#tblData")
                    .find("input[type=text], select")
                    .each(function () {
                        $(this).val("");
                    });

                    $("#tblData")
                    .find("input[type=date]")
                    .each(function () {
                        $(this).val('mm/dd/yyyy');
                    });

                $("#product_primary_id").val("");
                $("#customer_order_plan_data_id").val("");
                $("#trans_date_time").val("");
                tableData.reset();
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function getPlqData(id) {
    $.ajax({
        type: "GET",
        url: "/qc/PackingLineQualityRecordDataController/getPlqData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            // progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            $("#trans_date").val(res.trans_date);
            $("#customer_order_plan_data_id").val(
                res.customer_order_plan_data_id
            );
            $("#product_primary_id").val(res.product_primary_id);

            var request_data = res.request_data;
            for (var i = 0; i < request_data.length; i++) {
                tableData.addRow([
                    {
                        type: "select",
                        val: request_data[i].hour,
                        align: "left",
                        width: "60px",
                    },
                    {
                        type: "text",
                        val: request_data[i].seal_damage1,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].seal_damage2,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].seal_damage3,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].seal_damage4,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].seal_damage5,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].sed,
                        align: "left",
                        disabled: "disabled",
                    },
                    {
                        type: "text",
                        val: request_data[i].slab_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].print_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].packing_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].total,
                        align: "left",
                        disabled: "disabled",
                    },
                    {
                        type: "text",
                        val: request_data[i].sealing_length,
                        align: "left",
                    },
                    {
                        type: "select",
                        val: request_data[i].checked_by,
                        align: "left",
                        width: "160px",
                    },
                    {
                        type: "remove",
                        val: "X",
                        align: "center",
                    },
                ]);

                addRowData(request_data[i].checked_by, request_data[i].hour);
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function updatePlqRecords(plqr_id) {
    var plq_data = {};
    var plq_data_arr = tableData.dataSource();
    if (plq_data_arr.length == 0) {
        showWarningMessage("Invalied Data (Empty list)");
        return;
    }
    for (var i = 0; i < plq_data_arr.length; i++) {
        if (!plq_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        plq_data[i] = JSON.stringify({
            hour: plq_data_arr[i][0],
            seal_damage1: plq_data_arr[i][1],
            seal_damage2: plq_data_arr[i][2],
            seal_damage3: plq_data_arr[i][3],
            seal_damage4: plq_data_arr[i][4],
            seal_damage5: plq_data_arr[i][5],
            slab_damage: plq_data_arr[i][6],
            print_damage: plq_data_arr[i][7],
            packing_damage: plq_data_arr[i][8],
            sealing_length: plq_data_arr[i][11],
            checked_by: plq_data_arr[i][12],
        });
    }

    $.ajax({
        type: "PUT",
        url: "/qc/PackingLineQualityRecordDataController/update/" + plqr_id,
        data: {
            trans_date: $("#trans_date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            plq_data: plq_data,
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data updated");
                location.href = "/qc/packingLineList";
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function triggerRowInputs(id, selected_row) {
    if (id == "tblData") {
        var cells = selected_row.getElementsByTagName("td");
        var s1 = $("#" + cells[1].childNodes[0].id);
        var s2 = $("#" + cells[2].childNodes[0].id);
        var s3 = $("#" + cells[3].childNodes[0].id);
        var s4 = $("#" + cells[4].childNodes[0].id);
        var s5 = $("#" + cells[5].childNodes[0].id);
        var sld = $("#" + cells[7].childNodes[0].id);
        var prd = $("#" + cells[8].childNodes[0].id);
        var pad = $("#" + cells[9].childNodes[0].id);

        var input_arr = [s1, s2, s3, s4, s5, sld, prd, pad];

        input_arr.forEach((input) => {
            input.on("input", function () {
                var val_s1 = parseFloat(s1.val()) || 0;
                var val_s2 = parseFloat(s2.val()) || 0;
                var val_s3 = parseFloat(s3.val()) || 0;
                var val_s4 = parseFloat(s4.val()) || 0;
                var val_s5 = parseFloat(s5.val()) || 0;
                var val_sld = parseFloat(sld.val()) || 0;
                var val_prd = parseFloat(prd.val()) || 0;
                var val_pad = parseFloat(pad.val()) || 0;

                var sed =
                    val_s1 + val_s2 + val_s3 + val_s4 + val_s5;
                $("#" + cells[6].childNodes[0].id).val(sed);

                var total = sed + val_sld + val_pad + val_prd;
                $("#" + cells[10].childNodes[0].id).val(total);
            });
        });
    }
}

function transactionTableUpdate(table_id) {
    // override function from transaction_table.js
}



/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
